/*
 * readlink.c
 *
 * Copyright (C) 1993 Alain Knaff
 */
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <string.h>
#include "zlibc.h"
#include <syscall.h>

#ifdef NEED_PROTOTYPES
int readlink(__const char *path, char *buf, size_t len)
#else
int readlink(path,buf,len)
char *path, *buf; size_t len;
#endif
{
  int st;

  st = syscall(SYS_readlink,path,buf,len);

  if ( st >= 0 || errno != ENOENT )
    return st;
  {
    char newname[MAXPATHLEN + MAXEXTLEN + 1];

    zlib_initialise();
    if ( zlib_mode & CM_DISAB )
      return st;

    if ( zlib_mode & CM_VERBOSE )
      fprintf(stderr,"readlinking %s\n", path);


    strncpy(newname,path,1024);
    strcat(newname,zlib_ext);

    st = syscall(SYS_readlink,newname, buf, len);

    if ( st < 0 )
      return st;

    /* the file exists with z extension, ignore error */
    errno=0;
    return st;
  }
}
